#include "stdafx.h"

//-----------------------------------------------------------------
CVwTask :: CVwTask( ) {
	m_iPct=0;
	m_bCancelled=false;
	}
	
CVwTask :: ~CVwTask() { 
	}

HWND CVwTask :: CreateTaskWindow( HWND hMain, const char * pchChildClass ) { 
	//-- Open a task window 
	HWND hChildWin = CreateMDIWindow( pchChildClass, "Task progress", NULL, 
					CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
					hMain, GetInstance(), 0 );
	m_hDlg=CreateDialog( GetInstance(), MAKEINTRESOURCE(IDD_TASKVIEW), hChildWin, TaskViewDlgProc );
	SetWindowLong( GetParent(m_hDlg), 0, (long)this ) ;
	WindowListAdd( hChildWin, m_hDlg );
	return m_hDlg;
	}
	

void CVwTask :: SetPct( int iPct ){
	m_iPct=iPct;
	InvalidateRect( m_hDlg, NULL, TRUE );
	}
	
int CVwTask :: GetPct( ){
	return m_iPct;
	}

void CVwTask :: SetText(const char * pch){
	ShowWindow( GetDlgItem(m_hDlg, IDC_MESSAGE), strlen(pch)==0?SW_HIDE:SW_SHOWNA );
	SetWindowText( GetDlgItem(m_hDlg, IDC_MESSAGE), pch );
	}

void CVwTask :: OnCancel() {
	if( CanCancel() ) 
		m_bCancelled=true;
	}

bool CVwTask :: CanCancel() {
	return true;
	}

void CVwTask :: OnDestroy() {
	//
	}

void CVwTask :: OnPaint() { 		
	RECT rct;
	GetClientRect( m_hDlg, &rct );
	if( rct.right-rct.left>10 && rct.bottom-rct.top>10 ) {	
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(m_hDlg, &ps);
		rct.right = rct.left + MulDiv( m_iPct, rct.right-rct.left, 100 );
		//InflateRect( &rct, -5, -5 );
		HBRUSH brFill=CreateSolidBrush(m_bCancelled?RGB(255,0,0):RGB(64,64,255));
		FillRect( hdc, &rct, brFill );
		DeleteObject( brFill );
		EndPaint(m_hDlg, &ps);
		}
	}			
	

BOOL CALLBACK TaskViewDlgProc(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) { 
	//-- get the ViewClass, possibly NULL for initial messages 
	CVwTask * pVw = (CVwTask *) GetWindowLong(  GetParent( hDlg ), 0 );
	if( pVw==NULL ) 
		return FALSE;
	
	//-- Message handlers 
	int wmId, wmEvent;
	switch( iMsg ) { 

		case WM_TASKCOMPLETE : 
			DestroyWindow( GetParent( hDlg ) );
			break;

		case WM_TASKSETPCT : 
			pVw->SetPct( (int) wParam );
			return TRUE;

		case WM_TASKSETTEXT : 
			pVw->SetText( (const char *) wParam );
			return TRUE;

		case WM_PAINT :
			pVw->OnPaint();
			return FALSE;

		//-----
		case WM_COMMAND :
			wmId = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch( wmId ) { 
				//---- Cancel task
				case IDC_BTNCANCEL :
					pVw->OnCancel();
					return TRUE;
				}
			return FALSE;

		case WM_DESTROY :
			pVw->OnDestroy();
			delete pVw;
			SetWindowLong( GetParent(hDlg), 0, 0 ) ;
			WindowListRemove( hDlg );
			return TRUE;

		default : 
			break;
		}
		
	return FALSE;
	} 

